::===============================================================
:: The IntoVPN.net program to start
::
::===============================================================
@ECHO OFF
SETLOCAL
cls
Rem Settings
set working_folder=%CD%
set PROJECT_FOLDER=IntoVPNCmdWin
set deploy_folder=%working_folder%\\%PROJECT_FOLDER%
set temp_folder=C:\\Windows\\Temp\\%PROJECT_FOLDER%
set files_data=Datas.zip Executable.zip IntoVPNCmdWin.zip Wg.zip
set link_update=https://download.intovpn.net/cmdlines/install/win/1.0.0.0
set link_down_vcr=https://download.intovpn.net/preparing/vc_redist.x64.exe
Rem Set messages
set msg_not_sp_os=Sorry, this application's version doesn't support your OS
set title_glb=Welcome to IntoVPN.net
set title_sub=Installation
set msg_checking=The system is checking...
set msg_failed_tap=The application is exitting because Tap installing is failed. Try again the next time!
set msg_failed_vcr=The application is exitting because VC Redist installing is failed. Try again the next time!
set msg_failed_dl=The application is exiting beause getting data is failed. Try again the next time!
set msg_failed_extr=The application is exiting beause extracting data is failed. Try again the next time!
set msg_failed_env=The application is exiting beause can't setup. Try again the next time!
set msg_start_getdata=Getting datas ...
set msg_done_dl=Getting datas is successful!
set msg_tap_exists=Tap window is ready. Start updating the application!
set msg_tap_notexists=Tap window has been not installed. Please install this ...
set msg_vcr_exists=VC Redist is ready.
set msg_vcr_notexists=VC Redit has been not installed. Install now ...
set msg_just_install_tap=Tap window has been just installed. Start updating the application!
set msg_just_install_vcr=VC Redist has been just installed. Start updating the application!
set msg_start_extract=Extracting datas ...
set msg_done_extract=Extracting datas is successful!
set msg_done_upddata=Finish updating the application. Now start IntoVPN.net. Thank You!
Rem End-Set messages
Rem Settings
TITLE IntoVPN.net
echo ===========%title_glb%===========
echo %title_sub%
echo ============================================
@echo off
:: BatchGotAdmin
::-------------------------------------
REM  --> Check for permissions
IF "%PROCESSOR_ARCHITECTURE%" EQU "amd64" (
	>nul 2>&1 "%SYSTEMROOT%\SysWOW64\cacls.exe" "%SYSTEMROOT%\SysWOW64\config\system"
) ELSE (
	>nul 2>&1 "%SYSTEMROOT%\system32\cacls.exe" "%SYSTEMROOT%\system32\config\system"
)
REM --> If error flag set, we do not have admin.
if '%errorlevel%' NEQ '0' (
    echo Requesting administrative privileges...
    goto UACPrompt
) else ( goto gotAdmin )

:UACPrompt
    echo Set UAC = CreateObject^("Shell.Application"^) > "%temp%\getadmin.vbs"
    set params = %*:"="
    echo UAC.ShellExecute "cmd.exe", "/c %~s0 %params%", "", "runas", 1 >> "%temp%\getadmin.vbs"

    "%temp%\getadmin.vbs"
    del "%temp%\getadmin.vbs"
    exit /B
	
:gotAdmin
    pushd "%CD%"
    CD /D "%~dp0"

SET deploy_folder=C:\\%PROJECT_FOLDER%
::--------------------------------------
:: Check exists tap window
echo %msg_checking%
echo -----------
CALL :RequiredInstallTap
:: If required to install, check again
if %ERRORLEVEL% EQU 1 (
	:: Check with show the sys's error messages if exists
	reg query HKLM\SOFTWARE\TAP-Windows >nul
	if %ERRORLEVEL% EQU 0 (
		echo %msg_failed_tap%
		pause
		GOTO :EOF
	) else ( 
		echo %msg_just_install_tap%
		echo =======================================
	)
)
::--------------------------------------
echo -----------
CALL :RequiredInstallVCRedist
:: If required to install, check again
if %ERRORLEVEL% EQU 1 (
	:: Check with show the sys's error messages if exists
	reg query HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\VisualStudio\14.0\VC\Runtimes >nul
	if %ERRORLEVEL% EQU 0 (
		echo %msg_failed_vcr%
		pause
		GOTO :EOF
	) else ( 
		echo %msg_just_install_vcr%
		echo =======================================
	)
)
:: Remove
Tap\\tapinstall.exe remove tap0901
Tap\\tapctl.exe create --name IntoVPN.net
:: Go to this folder
echo %msg_start_getdata%
echo -----------
:: Delete folders if exists
if exist "%deploy_folder%" rmdir %deploy_folder%"
if exist "%temp_folder%" rmdir "%temp_folder%"
:: Create new folders
mkdir "%deploy_folder%"
mkdir "%temp_folder%"
:: Start getting data
CALL :DownloadZips
if %ERRORLEVEL% EQU 0 (
	echo -----------
	echo %msg_done_dl%
	echo =======================================
) else (
	echo %msg_failed_dl%
	:: Waiting for exit CMD
	pause
	GOTO :EOF
)
echo %msg_start_extract%
echo -----------
:: Start extracting data
CALL :ExtractDatas
if %ERRORLEVEL% EQU 1 (
	echo %msg_failed_extr%
	:: Waiting for exit CMD
	pause
	GOTO :EOF
) else (
	echo -----------
	echo %msg_done_extract%
	echo =======================================
)
echo %msg_done_upddata%
pause
GOTO :EOF
Rem Functions
:RequiredInstallTap
set isRequired=0
:: Check with show the sys's error messages if exists
reg query HKLM\SOFTWARE\TAP-Windows >nul
if %ERRORLEVEL% EQU 0 (
	:: Not found error
	echo %msg_tap_exists%
	echo =======================================
) else (
	:: Has error
	set isRequired=1
	echo %msg_tap_notexists%
	echo -----------
	START /WAIT Tap\\tapV9.exe
)
:: Return with ERRORLEVEL EQU 0
EXIT /B %isRequired%
:RequiredInstallVCRedist
:: Check with show the sys's error messages if exists
set isRequiredVCR=0
:: Check with show the sys's error messages if exists
reg query HKEY_LOCAL_MACHINE\SOFTWARE\Microsoft\VisualStudio\14.0\VC\Runtimes >nul
if %ERRORLEVEL% EQU 0 (
	:: Not found error
	echo %msg_vcr_exists%
	echo =======================================
) else (
	:: Has error
	set isRequiredVCR=1
	echo %msg_vcr_notexists%
	::Download
	echo Downloading...
	wget %link_down_vcr%
	ehco Installing...
	echo -----------
	START /WAIT vc_redist.x64.exe
)
:: Return with ERRORLEVEL EQU 0
EXIT /B %isRequiredVCR%
:DownloadZips
set is_error=0
SETLOCAL ENABLEDELAYEDEXPANSION
FOR %%a IN (%files_data%) DO (
	Rem echo Downloading from %link_update%/%%a
	echo Downloading from ...
	echo Creating file %%a
	Rem powershell -Command "Invoke-WebRequest %link_update%/%%a -OutFile %temp_folder%\\%%a"
	wget -P %temp_folder% %link_update%/%%a
	:: Check exists file after downloaded
	IF NOT EXIST "%temp_folder%\\%%a" (
		:: Has error, so break
		set is_error=1
		BREAK
	)
)
EXIT /B %is_error%
:ExtractDatas
:: Delete foler %deploy_folder% if exists
IF EXIST "%deploy_folder%" (
	rmdir /q /s "%deploy_folder%"
)
SETLOCAL ENABLEDELAYEDEXPANSION
FOR %%a in (%files_data%) do (
	::Extract to temp folder
	echo Extracting file %%a to "%deploy_folder%"
	Rem powershell Expand-Archive "%temp_folder%\\%%a" -DestinationPath "%deploy_folder%"
	unzip -o %temp_folder%\\%%a -d %deploy_folder%
)
EXIT /B 0
Rem End-Functions